using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using MySql.Data.MySqlClient;
using fatd_faturamento.ENTIDADE;
using fatd_faturamento.DAL.Conexao;

namespace fatd_faturamento.DAL.Persistencia
{
    public class dalRastreamento
    {

        string vFILTER = null;
        string vINNERJOIN = null;
        string vAND = null;
        string vORDERBY = null;

        #region Métodos

        public void Insert(entidadeRastreamento objRastreamento)
        {
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vFILTER = vFILTER + "DATA = ?DATA, ";
                    vFILTER = vFILTER + "DESCRICAO = ENCODE(?DESCRICAO , 'NSS2010*'), ";
                    vFILTER = vFILTER + "COD_USUARIO =  ?COD_USUARIO , ";
                    vFILTER = vFILTER + "LOGIN_USUARIO = ?LOGIN_USUARIO , ";
                    vFILTER = vFILTER + "NOME_COMPUTADOR = ENCODE(?NOME_COMPUTADOR , 'NSS2010*'), ";
                    vFILTER = vFILTER + "MAC_ADDRESS = ENCODE(?MAC_ADDRESS , 'NSS2010*'), ";
                    vFILTER = vFILTER + "VERSAO = ?VERSAO ";

                    cmd = new MySqlCommand(this.QueryInsert);

                    cmd.Parameters.AddWithValue("?DATA", objRastreamento.DATA);
                    cmd.Parameters.AddWithValue("?DESCRICAO", objRastreamento.DESCRICAO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?COD_USUARIO", objRastreamento.COD_USUARIO);
                    cmd.Parameters.AddWithValue("?LOGIN_USUARIO", objRastreamento.LOGIN_USUARIO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?NOME_COMPUTADOR", objRastreamento.NOME_COMPUTADOR.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?MAC_ADDRESS", objRastreamento.MAC_ADDRESS.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?VERSAO", objRastreamento.VERSAO.ToString().ToUpper());

                    objGerenciadorTransacao.Execute(cmd);
                }
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        #endregion

        #region " Comandos SQL "

        StringBuilder sb = new StringBuilder();


        protected string QueryInsert
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("INSERT INTO  ");
                this.sb.AppendLine("RASTREAMENTO SET  ");
                this.sb.AppendLine(vFILTER);

                return sb.ToString();
            }
        }

        protected string QueryUpdate
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("UPDATE  ");
                this.sb.AppendLine("RASTREAMENTO SET  ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);

                return sb.ToString();
            }
        }

        protected string QueryDelete
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("DELETE FROM RASTREAMENTO ");
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }

        protected string QuerySelect
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("SELECT ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("FROM ");
                this.sb.AppendLine("RASTREAMENTO  ");
                this.sb.AppendLine(vINNERJOIN);
                this.sb.AppendLine("WHERE 1 = 1  ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }

        #endregion

    }
}
